Index: /trunk/gsdl/src/recpt/OIDtools.cpp
===================================================================
--- /trunk/gsdl/src/recpt/OIDtools.cpp	(revision 1346)
+++ /trunk/gsdl/src/recpt/OIDtools.cpp	(revision 1347)
@@ -104,4 +104,36 @@
 }
 
+// overloaded, to allow "custom" filter options.
+bool get_info (const text_t &OID, const text_t &collection,
+	       const text_tset &metadata, const OptionValue_tarray &options,
+	       bool getParents,
+	       recptproto *collectproto, FilterResponse_t &response, 
+	       ostream &logout) {
+
+  response.clear();
+
+  comerror_t err;
+  FilterRequest_t request;
+
+  request.filterName = "NullFilter";
+  request.filterResultOptions = FRmetadata;
+  request.getParents = getParents;
+  request.filterOptions = options;
+  request.fields = metadata;
+  request.docSet.push_back (OID);
+  
+  collectproto->filter (collection, request, response, err, logout);
+  if (err != noError) {
+    outconvertclass text_t2ascii;
+    logout << text_t2ascii
+	   << "Error: call to filter failed for " << OID
+	   << " in OIDtools::get_info (" 
+	   << get_comerror_string (err) << ")\n";
+    return false;
+  }
+  
+  return true;
+}
+
 bool get_info (const text_tarray &OIDs, const text_t &collection,
 	       const text_tset &metadata, bool getParents,
@@ -133,4 +165,6 @@
   return true;
 }
+
+
 
 // has_children returns true if OID has children
Index: /trunk/gsdl/src/recpt/OIDtools.h
===================================================================
--- /trunk/gsdl/src/recpt/OIDtools.h	(revision 1346)
+++ /trunk/gsdl/src/recpt/OIDtools.h	(revision 1347)
@@ -49,4 +49,9 @@
 	       recptproto *collectproto, FilterResponse_t &response, 
 	       ostream &logout);
+bool get_info (const text_t &OID, const text_t &collection,
+	       const text_tset &metadata, const OptionValue_tarray &options,
+	       bool getParents,
+	       recptproto *collectproto, FilterResponse_t &response, 
+	       ostream &logout);
 bool get_info (const text_tarray &OIDs, const text_t &collection,
 	       const text_tset &metadata, bool getParents,
Index: /trunk/gsdl/src/recpt/TODO
===================================================================
--- /trunk/gsdl/src/recpt/TODO	(revision 1347)
+++ /trunk/gsdl/src/recpt/TODO	(revision 1347)
@@ -0,0 +1,57 @@
+For Z 39.50 Stuff
+
+pageaction.cpp
+--------------
+Macros:
+ * for "about" page, use a custom _textbrowseoptions_ macro (ie
+   create a new macro, maybe create a z3950.dm macro file ??)
+   (also maybe _numbrowseoptions_
+
+(Irrelevant?) (c. line 332)
+    disp.setmacro ("numdocs", "Global", cinfo.numDocs);
+    disp.setmacro ("builddate", "Global", builddate);
+
+That message "This collection contains..." is in the _collectionextra_
+macro.
+could get numdocs from the z39.50 server, as well as any other status
+information.
+
+win32.mak
+---------
+Needs updating for all added files (z*, parse.fl)
+
+yaz
+---
+Maybe put libyaz.a in $GSDLHOME/lib ?
+
+
+DESIGN ISSUES
+for z39.50 (and eventually nullproto when corba allows recept. and
+coll server to be physically separate), if the server is unavailable,
+should this be determined at:
+  * "home page" creation time, in which case the recept. must ping and
+test each collection it knows about, which may cause unacceptable delay, or
+  * "about page" creation time (ie individual collection), in which case
+the collection can not customise the page layout by modifying macros.
+
+Eg currently, the z39.50 collection will not create a TCP connection to the
+"target" (ie z39.50 server somewhere around the world) until it tries to
+get the "About this collection" information for that collection. 
+If the connection fails, the protocol can not change _queryform_ part of
+the page.
+
+
+MULTI-LINGUAL SUPPORT
+Multi-lingual - eg macros - want to set _collectionextra_ using
+metadata["collectionextra"] based on the chosen interface language.
+Should be done by OIDtools.cpp:get_info() and any action that calls
+proto->filter().
+queryaction.cpp (c. line 1097):
+  // add the requested language as an option to the query
+  if (!args["l"].empty()) {
+    OptionValue_t option;
+    option.name="Language";
+    option.value=args["l"];
+    request.filterOptions.push_back(option);
+  }
+
Index: /trunk/gsdl/src/recpt/cgiwrapper.cpp
===================================================================
--- /trunk/gsdl/src/recpt/cgiwrapper.cpp	(revision 1346)
+++ /trunk/gsdl/src/recpt/cgiwrapper.cpp	(revision 1347)
@@ -376,17 +376,42 @@
   recptprotolistclass::iterator rprotolist_here = protos->begin();
   recptprotolistclass::iterator rprotolist_end = protos->end();
+
+  bool is_z3950 = false;
   bool found_valid_col = false;
+
   while (rprotolist_here != rprotolist_end) {
-    if ((*rprotolist_here).p != NULL) {
-
-      text_tarray collist;
-      comerror_t err;
-      (*rprotolist_here).p->get_collection_list (collist, err, cerr);
-      if (err == noError) {
-	text_tarray::iterator collist_here = collist.begin();
-	text_tarray::iterator collist_end = collist.end();
-
-	while (collist_here != collist_end) {
+    if ((*rprotolist_here).p == NULL) continue;
+    else if (is_z3950==false &&
+	     (*rprotolist_here).p->get_protocol_name() == "z3950proto") {
+      cout << "\nZ39.50 Servers:   (always public)\n"
+	   << "---------------\n";
+      is_z3950=true;
+    }
+
+    text_tarray collist;
+    comerror_t err;
+    (*rprotolist_here).p->get_collection_list (collist, err, cerr);
+    if (err == noError) {
+      text_tarray::iterator collist_here = collist.begin();
+      text_tarray::iterator collist_end = collist.end();
+      
+      while (collist_here != collist_end) {
+	
+	cout << text_t2ascii << *collist_here;
+	
+	int spaces = (22 - (*collist_here).size());
+	if (spaces < 2) spaces = 2;
+	text_t outspaces;
+	for (int i = 0; i < spaces; i++) outspaces.push_back (' ');
+	cout << text_t2ascii << outspaces;
+	
+	ColInfoResponse_t cinfo;
+	(*rprotolist_here).p->get_collectinfo (*collist_here, cinfo, err, cerr);
+	if (err == noError && is_z3950 == false) {
+	  if (cinfo.isPublic) cout << "public ";
+	  else cout << "private";
 	  
+	  if (cinfo.buildDate > 0) cout << "   running    ";
+	  else cout << "   not running";
 	  cout << text_t2ascii << *collist_here;
 
@@ -414,8 +439,13 @@
 	  collist_here ++;
 	}
+	
+	cout << "\n";
+	
+	collist_here ++;
       }
     }
+    is_z3950=false;
     rprotolist_here ++;
-  }
+  } // end of while loop
   
   if (!found_valid_col) {
Index: /trunk/gsdl/src/recpt/documentaction.cpp
===================================================================
--- /trunk/gsdl/src/recpt/documentaction.cpp	(revision 1346)
+++ /trunk/gsdl/src/recpt/documentaction.cpp	(revision 1347)
@@ -365,10 +365,19 @@
   text_tset metadata;
 
-  ColInfoResponse_t *cinfo = recpt->get_collectinfo_ptr (collectproto, collection, logout);
-  if (cinfo == NULL) {
-    logout << "ERROR (documentaction::define_external_macros): get_collectinfo_ptr returned NULL\n";
-    return;
-  }
-  load_formatinfo (cinfo->format, args.getintarg("gt"));
+  // get info on current collection and load up formatinfo
+  // I'd prefer not to do this here as we're getting 
+  // collection info every time (and probably also getting
+  // it in other places some of the time) - One day I'll
+  // fix it ... maybe - Stefan.
+  ColInfoResponse_t cinfo;
+
+  collectproto->get_collectinfo (collection, cinfo, err, logout);
+  load_formatinfo (cinfo.format, args.getintarg("gt"));
+  //  ColInfoResponse_t *cinfo = recpt->get_collectinfo_ptr (collectproto, collection, logout);
+  //  if (cinfo == NULL) {
+  //    logout << "ERROR (documentaction::define_external_macros): get_collectinfo_ptr returned NULL\n";
+  //    return;
+  //  }
+  //load_formatinfo (cinfo->format, args.getintarg("gt"));
 
   if (formatinfo.DocumentUseHTML) {
@@ -594,7 +603,17 @@
 
     metadata.insert ("archivedir");
-    
+
+    OptionValue_tarray options;
+    // we need to know what the query was for the z3950proto
+    if (collectproto->get_protocol_name()=="z3950proto") {
+      OptionValue_t opt;
+      opt.name="Query";
+      opt.value=args["q"];
+      options.push_back(opt);
+    }
+
     // get metadata for this document and it's parents
-    if (get_info (arg_d, collection, metadata, true, collectproto, response, logout)) {
+    if (get_info (arg_d, collection, metadata, options, 
+		  true, collectproto, response, logout)) {
       disp.setmacro ("header", "document", "_textheader_");
 
Index: /trunk/gsdl/src/recpt/librarymain.cpp
===================================================================
--- /trunk/gsdl/src/recpt/librarymain.cpp	(revision 1346)
+++ /trunk/gsdl/src/recpt/librarymain.cpp	(revision 1347)
@@ -27,4 +27,6 @@
 #include "cgiwrapper.h"
 #include "nullproto.h"
+// z39.50 stuff - johnmcp
+#include "z3950proto.h"
 #include "collectserver.h"
 #include "filter.h"
@@ -64,4 +66,5 @@
   receptionist recpt;
   nullproto nproto;
+  z3950proto zproto;
 
   text_tarray collections;
@@ -120,4 +123,5 @@
     browsefilterclass *browsefilter = new browsefilterclass();
     browsefilter->set_gdbmptr (gdbmhandler);
+
     cserver->add_filter (browsefilter);  
  
@@ -136,5 +140,4 @@
        mggdbmsource->set_mgsearchptr (mgsearch);
        cserver->add_source (mggdbmsource);
-   
     }
     else if (buildtype == "mgpp") {
@@ -166,5 +169,5 @@
     colinfo.push_back (gsdlhome);
     recpt.configure ("collectinfo", colinfo);
-  
+    
     nproto.add_collectserver (cserver);
     thiscol ++;
@@ -174,4 +177,21 @@
   recpt.add_protocol (&nproto);
   
+
+
+  // z39.50 stuff - johnmcp
+
+  // add the z39.50 server information. Read in the file
+  // etc/recpt/z3950.cfg for list of servers and their databases.
+  text_t z3950cfg = filename_cat (gsdlhome, "etc");
+  z3950cfg = filename_cat (z3950cfg, "recpt");
+  z3950cfg = filename_cat (z3950cfg, "z3950.cfg");
+  if (file_exists(z3950cfg)) {
+    zproto.read_config_file(z3950cfg);
+    // only add this protocol if we have any servers configured.
+    if (zproto.getServerCount()>0)
+      recpt.add_protocol (&zproto);
+  }
+
+
   // add other converters
   utf8inconvertclass utf8inconvert;
Index: /trunk/gsdl/src/recpt/pageaction.cpp
===================================================================
--- /trunk/gsdl/src/recpt/pageaction.cpp	(revision 1346)
+++ /trunk/gsdl/src/recpt/pageaction.cpp	(revision 1347)
@@ -148,9 +148,15 @@
 	  collist_here ++;
 	}
+
+	// disp.setmacro ("homeextra", "home", homeextra); 
 	for (; count%3 != 0; count ++) homeextra += "<td></td>\n";
       }
     }
+    homeextra += "</td></tr>\n<tr>\n";
     rprotolist_here ++;
   }
+
+  homeextra += "</tr></table></center>\n";
+  disp.setmacro ("homeextra", "home", homeextra); 
 
   if (!found_valid_col) {
Index: /trunk/gsdl/src/recpt/parse.fl
===================================================================
--- /trunk/gsdl/src/recpt/parse.fl	(revision 1347)
+++ /trunk/gsdl/src/recpt/parse.fl	(revision 1347)
@@ -0,0 +1,112 @@
+/* This is the lexical analyser - it returns tokens to the parsers.
+   This is used by both parsers - one for the build-time config files
+   and one for the run-time config files. Note the included file "parse.h"
+   is a symlink to the relevant header file. */
+
+%{
+#include <string.h>
+#include <stdlib.h>
+#include <stdio.h>
+
+/*#define YYSTYPE char * - YYSTYPE is defined in zparse.tab.h */
+#include "zparse.tab.h"
+
+/* forward declarations for std functions not picked up. */
+/*int fileno(FILE *);*/
+/*char *strdup(char *);*/
+
+int lineno=1;
+%}
+
+%option noyywrap
+
+COMMENT  \#.*(\n|\r)
+
+%x  STRINGCOND
+%%
+	char *string;
+	int string_len;
+
+{COMMENT}		lineno++;/*yylval.string=yytext;*/yyleng=0;
+,			return (',');
+:			return (':');
+\_			return ('_');
+\[GSDL[0-9]+\.[0-9]+\] yylval.string=yytext;return(GSDLVERSION);
+\[General\]		return (GENERAL_SECTION);
+\[Search\ [fF]ields\]	return (SEARCH_SECTION);
+\[Browse\ [fF]ields\]	return (BROWSE_SECTION);
+\[Macros\]		return (MACROS_SECTION);
+maintainer		return (MAINTAINER);
+Languages		return(LANGUAGES);
+About			return(ABOUT);
+Browse			return(BROWSE);
+Date[lL]ist		return(DATELIST);
+Document[aA]rrows[bB]ottom return(DOCUMENTARROWSBOTTOM);
+Document[bB]uttons	return(DOCUMENTBUTTONS);
+Document[hH]eader	return(DOCUMENTHEADER);
+Document[iI]mages	return(DOCUMENTIMAGES);
+Document[tT]ext		return(DOCUMENTTEXT);
+Icon[lL]ink		return(ICONLINK);
+List			return(LIST);
+Format			return(FORMAT);
+Name			return(NAME);
+Search[tT]ext		return(SEARCHTEXT);
+Section[lL]ist		return(SECTIONLIST);
+Sorted[lL]ist		return(SORTEDLIST);
+Sorted[sS]ection[lL]ist	return(SORTEDSECTIONLIST);
+Text[lL]ink		return(TEXTLINK);
+Type			return(TYPE);
+public			return (PUBLIC);
+true			return (TRUE);
+false			return (FALSE);
+^document		return (DOCUMENT);
+^section		return (SECTION);
+[iI]con			return (ICON);
+[sS]mall[iI]con		return (SMALLICON);
+\"			{string=NULL;BEGIN(STRINGCOND);}
+<STRINGCOND>{
+  ([^\"\\\n])*		{/* append this to our current string EXC NEWLINE */
+			if (string==NULL) string_len=0; else
+			string_len=strlen(string);
+			string=realloc(string,string_len+strlen(yytext)+1);
+			/* +1 is for trailing \0 */
+			strcpy(string+string_len,yytext);
+			}
+  ([^\"\\])*\n		{/* append this to our current string - INC NEWLINE */
+			lineno++;
+			if (string==NULL) string_len=0; else
+			string_len=strlen(string);
+			string=realloc(string,string_len+strlen(yytext)+1);
+			/* +1 is for trailing \0 */
+			strcpy(string+string_len,yytext);
+			}
+  "\\"\"		|
+  \"\"		{       /*replace quoted quote with one quote*/
+			string_len=strlen(string);
+			string=realloc(string,string_len+2);
+			string[string_len]='\"';
+			string[string_len+1]='\0';
+			}
+  \"		{
+			BEGIN(INITIAL);
+			yylval.string=string;
+			return(STRING);
+			  /* note that the string may have long bits of 
+			     whitespace in it that we could remove. */
+			}
+}
+[[:alnum:]@\.-]+	yylval.string=strdup(yytext);return (DATA);
+(" "|\t)		;
+(\n|\r)			lineno++;
+%%
+/******** deleted rules: *******
+en			return(EN);
+fr			return(FR);
+mi			return(MI);
+zh			return(ZH);
+de			return(DE);
+***************/
+
+
+
+
Index: /trunk/gsdl/src/recpt/z3950cfg.h
===================================================================
--- /trunk/gsdl/src/recpt/z3950cfg.h	(revision 1347)
+++ /trunk/gsdl/src/recpt/z3950cfg.h	(revision 1347)
@@ -0,0 +1,29 @@
+/*
+  This defines a data structure shared between:
+  * the C++ z3950proto class defined in z3950proto.cpp, and
+  * the C function yyparse() created by bison from the file zparse.fl
+  */
+
+#ifndef _Z3950CFG_H
+#define _Z3950CFG_H
+
+struct z3950aboutlist {
+  char *lang;
+  char *text;
+  struct z3950aboutlist *next;
+};
+struct z3950cfg {
+  char *shortname;
+  char *hostname;
+  int port;
+  char *dbname;
+  char *longname;
+  char *icon;
+  char *smallicon;
+  struct z3950aboutlist *about;
+  struct z3950cfg *next;
+};
+struct z3950cfg *zserver_list;
+#else
+extern struct z3950cfg *zserver_list;
+#endif
